package fr.dgedl.demo.persistence.dao;

import java.util.List;

public interface GenericDao<T extends Object> {

	/**
	 * cration/mise  jour d'un pojo
	 * @param pojo
	 * @return
	 */
	T save(T pojo);

	/**
	 * suppression d'un pojo en le chargeant via son id
	 * @param classe
	 * @param id
	 */
	void remove(Class<T> classe, int id);

	/**
	 * suppression d'un pojo sans le recharger
	 * @param pojo
	 */
	void delete(T pojo);

	/**
	 * recherche un pojo via son id
	 * @param classe
	 * @param id
	 * @return
	 */
	T findById(Class<T> classe, int id);
	
	/**
	 * retourne la liste des pojos
	 * @param classe
	 * @return
	 */
	List<T> findAll(Class<T> classe);

	/**
	 * recherche via une requete JPQL
	 * @param classe
	 * @param query
	 * @return
	 */
	List<T> findByQuery(String jpql);

}
