package fr.dgedl.demo.persistence.dao.impl;

import javax.persistence.NoResultException;
import javax.persistence.Query;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.springframework.stereotype.Repository;

import fr.dgedl.demo.persistence.dao.UserAccountDao;
import fr.dgedl.demo.persistence.entity.UserAccount;

@Repository
public class UserAccountDaoImpl extends GenericDaoImpl<UserAccount> implements UserAccountDao {
	
	private static final Log LOG = LogFactory.getFactory().getInstance(UserAccountDaoImpl.class);

	@Override
	public UserAccount findAccount(String email, String cryptedPassword) {
		Query query = em.createNamedQuery("UserAccount.login");
		query.setParameter("email", email);
		query.setParameter("password", cryptedPassword);
		
		UserAccount account = null;
		try {
			account = (UserAccount) query.getSingleResult();
		} catch (NoResultException nre) {
			LOG.info("Email ou mot de passe incorrect");
		}
		return account;
	}
	
}