package fr.dgedl.demo.persistence.entity;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

@NamedQueries({ @NamedQuery(name = "UserAccount.login", query = "FROM UserAccount WHERE email = :email AND password = :password") })

@Entity
@Table(name = "USER_ACCOUNT")
public class UserAccount implements Serializable {

	private static final long serialVersionUID = -3805676305469317938L;

	@Id
	@GeneratedValue
	@Column(name = "ID")
	private Integer id;

	@Column(name = "EMAIL", nullable = false, length = 100)
	private String email;

	@Column(name = "PASSWORD", nullable = false, length = 250)
	private String password;

	@Column(name = "SECURITY", nullable = false, length = 50)
	private String security;

	@Override
	public boolean equals(Object aThat) {
		if (this == aThat) {
			return true;
		}
		if (!(aThat instanceof UserAccount)) {
			return false;
		}

		UserAccount that = (UserAccount) aThat;
		return id != null ? id.equals(that.id) : email.equals(that.email);
	}

	@Override
	public int hashCode() {
		return id != null ? id.hashCode() : email.hashCode();
	}

	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}

	public Integer getId() {
		return id;
	}
	public void setId(Integer id) {
		this.id = id;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public String getPassword() {
		return password;
	}
	public void setPassword(String password) {
		this.password = password;
	}
	public String getSecurity() {
		return security;
	}
	public void setSecurity(String security) {
		this.security = security;
	}

}