package fr.dgedl.demo.service;

import java.util.List;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.util.Assert;

import fr.dgedl.demo.jndi.ContextDatasourceCreator;
import fr.dgedl.demo.persistence.entity.UserAccount;

@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration("/spring/applicationContext.xml")
public class UserServiceTest extends Assert {

	private static final Log LOG = LogFactory.getFactory().getInstance(UserServiceTest.class);
	
	@Autowired
	private UserService userService;

	@BeforeClass
	public static void setUpOnce() {
		LOG.info("setUpOnce()");
		ContextDatasourceCreator.init();
	}
	@AfterClass
	public static void tearDownOnce() {
		LOG.info("tearDownOnce()");
	}
	
	@Before
	public void onSetUp() {
		LOG.info("onSetUp()");
	}
	@After
	public void OnTearDown() {
		LOG.info("OnTearDown()");
	}

	@Test
	public void testListAll() {
		List<UserAccount> allUserAccounts = userService.getAllAccounts();
		for (UserAccount userAccount : allUserAccounts) {
			LOG.info(userAccount);
		}
	}
	
}